#! /usr/bin/env python
# -*- coding: utf-8 -*-

from vec2d import vec2d
import pygame 

class TileMap(object):
    def __init__(self):
        self.tiles = [[]]
        self.size = vec2d(0, 0)
        self.tileSheet = pygame.Surface(self.size)
    
    def load_from(self, file, tileSheet):
        f = open(file, "r")
        lines = f.readlines()
        f.close()
        
        i = 0
        x = int(lines[i])
        i += 1
        y = int(lines[i])
        i += 1
        
        tiles = []
        for iy in range(y):
            numbers = map(int, lines[i].split())
            i += 1
            tiles.append(numbers)
        self.tiles = tiles
        self.tileSheet = tileSheet
        self.size = vec2d(x, y)
    
    def get_tile_at(self, pos):
        pos = vec2d(pos)
        return self.tiles[int(pos.y)][int(pos.x)]
    
    def hit_test(self, position):
        position = vec2d(position)
        tile = self.get_tile_at(position//9)
        return tile < 20
    
    def get_rect_from_tileSheet(self, number):
        reihe = number / 10
        spalte = number % 10
        x = spalte * 10
        y = reihe * 10
        return pygame.Rect((x, y), (x+9, y+9))
    
    def draw(self, surface):
        for x in range(self.size.x):
            for y in range(self.size.y):
                surface.blit(self.tileSheet, vec2d(x, y) * 9, self.get_rect_from_tileSheet(self.get_tile_at((x, y))))